Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -2165,68 +2436,61 @@
  SUBROUTINE salsa_driver( i, j, prunmode )
 
-    USE arrays_3d,                                                             &
-        ONLY: pt_p, q_p, rho_air_zw, u, v, w
-        
-    USE plant_canopy_model_mod,                                                &
+    USE arrays_3d,                                                                                 &
+        ONLY: pt_p, q_p, u, v, w
+
+    USE plant_canopy_model_mod,                                                                    &
         ONLY: lad_s
-        
-    USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h,     &
-               surf_usm_v
- 
+
+    USE surface_mod,                                                                               &
+        ONLY:  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, surf_usm_v
+
     IMPLICIT NONE
-    
-    INTEGER(iwp), INTENT(in) ::  i   !< loop index
-    INTEGER(iwp), INTENT(in) ::  j   !< loop index
-    INTEGER(iwp), INTENT(in) ::  prunmode !< 1: Initialization call
-                                          !< 2: Spinup period call
-                                          !< 3: Regular runtime call
-!-- Local variables
-    TYPE(t_section), DIMENSION(fn2b) ::  aero_old !< helper array 
-    INTEGER(iwp) ::  bb     !< loop index
-    INTEGER(iwp) ::  cc     !< loop index
-    INTEGER(iwp) ::  endi   !< end index
-    INTEGER(iwp) ::  k_wall !< vertical index of topography top
-    INTEGER(iwp) ::  k      !< loop index
-    INTEGER(iwp) ::  l      !< loop index
-    INTEGER(iwp) ::  nc_h2o !< index of H2O in the prtcl index table 
-    INTEGER(iwp) ::  ss     !< loop index
-    INTEGER(iwp) ::  str    !< start index
-    INTEGER(iwp) ::  vc     !< default index in prtcl
-    REAL(wp) ::  cw_old     !< previous H2O mixing ratio 
-    REAL(wp) ::  flag       !< flag to mask topography grid points
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_adn !< air density (kg/m3)    
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_cs  !< H2O sat. vapour conc.
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_cw  !< H2O vapour concentration
-    REAL(wp) ::  in_lad                       !< leaf area density (m2/m3)
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_p   !< pressure (Pa)     
-    REAL(wp) ::  in_rh                        !< relative humidity                     
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_t   !< temperature (K)
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_u   !< wind magnitude (m/s) 
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  kvis   !< kinematic viscosity of air(m2/s)                                            
-    REAL(wp), DIMENSION(nzb:nzt+1,fn2b) ::  Sc      !< particle Schmidt number    
-    REAL(wp), DIMENSION(nzb:nzt+1,fn2b) ::  vd      !< particle fall seed (m/s,
-                                                    !< sedimentation velocity)
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  ppm_to_nconc !< Conversion factor 
-                                                    !< from ppm to #/m3                                                     
-    REAL(wp) ::  zgso4  !< SO4
-    REAL(wp) ::  zghno3 !< HNO3
-    REAL(wp) ::  zgnh3  !< NH3
-    REAL(wp) ::  zgocnv !< non-volatile OC
-    REAL(wp) ::  zgocsv !< semi-volatile OC 
-    
+
+    INTEGER(iwp) ::  endi    !< end index
+    INTEGER(iwp) ::  ib      !< loop index
+    INTEGER(iwp) ::  ic      !< loop index
+    INTEGER(iwp) ::  ig      !< loop index
+    INTEGER(iwp) ::  k_wall  !< vertical index of topography top
+    INTEGER(iwp) ::  k       !< loop index
+    INTEGER(iwp) ::  l       !< loop index
+    INTEGER(iwp) ::  nc_h2o  !< index of H2O in the prtcl index table
+    INTEGER(iwp) ::  ss      !< loop index
+    INTEGER(iwp) ::  str     !< start index
+    INTEGER(iwp) ::  vc      !< default index in prtcl
+
+    INTEGER(iwp), INTENT(in) ::  i         !< loop index
+    INTEGER(iwp), INTENT(in) ::  j         !< loop index
+    INTEGER(iwp), INTENT(in) ::  prunmode  !< 1: Initialization, 2: Spinup, 3: Regular runtime
+
+    REAL(wp) ::  cw_old  !< previous H2O mixing ratio
+    REAL(wp) ::  flag    !< flag to mask topography grid points
+    REAL(wp) ::  in_lad  !< leaf area density (m2/m3)
+    REAL(wp) ::  in_rh   !< relative humidity
+    REAL(wp) ::  zgso4   !< SO4
+    REAL(wp) ::  zghno3  !< HNO3
+    REAL(wp) ::  zgnh3   !< NH3
+    REAL(wp) ::  zgocnv  !< non-volatile OC
+    REAL(wp) ::  zgocsv  !< semi-volatile OC
+
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_adn  !< air density (kg/m3)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_cs   !< H2O sat. vapour conc.
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_cw   !< H2O vapour concentration
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_p    !< pressure (Pa)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_t    !< temperature (K)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  in_u    !< wind magnitude (m/s)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  kvis    !< kinematic viscosity of air(m2/s)
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  ppm_to_nconc  !< Conversion factor from ppm to #/m3
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nbins_aerosol) ::  schmidt_num  !< particle Schmidt number
+    REAL(wp), DIMENSION(nzb:nzt+1,nbins_aerosol) ::  vd           !< particle fall seed (m/s)
+
+    TYPE(t_section), DIMENSION(nbins_aerosol) ::  aero_old !< helper array
+
     aero_old(:)%numc = 0.0_wp
-    in_adn           = 0.0_wp    
-    in_cs            = 0.0_wp
-    in_cw            = 0.0_wp 
     in_lad           = 0.0_wp
-    in_rh            = 0.0_wp
-    in_p             = 0.0_wp 
-    in_t             = 0.0_wp 
     in_u             = 0.0_wp
     kvis             = 0.0_wp
-    Sc               = 0.0_wp
+    schmidt_num      = 0.0_wp
     vd               = 0.0_wp
-    ppm_to_nconc     = 1.0_wp
     zgso4            = nclim
     zghno3           = nclim
@@ -2234,46 +2498,39 @@
     zgocnv           = nclim
     zgocsv           = nclim
-    
-!       
+!
 !-- Aerosol number is always set, but mass can be uninitialized
-    DO cc = 1, nbins
-       aero(cc)%volc     = 0.0_wp
-       aero_old(cc)%volc = 0.0_wp
-    ENDDO 
-!    
+    DO ib = 1, nbins_aerosol
+       aero(ib)%volc(:)     = 0.0_wp
+       aero_old(ib)%volc(:) = 0.0_wp
+    ENDDO
+!
 !-- Set the salsa runtime config (How to make this more efficient?)
     CALL set_salsa_runtime( prunmode )
-!             
+!
 !-- Calculate thermodynamic quantities needed in SALSA
-    CALL salsa_thrm_ij( i, j, p_ij=in_p, temp_ij=in_t, cw_ij=in_cw,            &
-                        cs_ij=in_cs, adn_ij=in_adn )
+    CALL salsa_thrm_ij( i, j, p_ij=in_p, temp_ij=in_t, cw_ij=in_cw, cs_ij=in_cs, adn_ij=in_adn )
 !
 !-- Magnitude of wind: needed for deposition
     IF ( lsdepo )  THEN
-       in_u(nzb+1:nzt) = SQRT(                                                 &
-                   ( 0.5_wp * ( u(nzb+1:nzt,j,i) + u(nzb+1:nzt,j,i+1) ) )**2 + &  
-                   ( 0.5_wp * ( v(nzb+1:nzt,j,i) + v(nzb+1:nzt,j+1,i) ) )**2 + &
-                   ( 0.5_wp * ( w(nzb:nzt-1,j,i) + w(nzb+1:nzt,j,  i) ) )**2 )
+       in_u(nzb+1:nzt) = SQRT( ( 0.5_wp * ( u(nzb+1:nzt,j,i) + u(nzb+1:nzt,j,i+1) ) )**2 +         &
+                               ( 0.5_wp * ( v(nzb+1:nzt,j,i) + v(nzb+1:nzt,j+1,i) ) )**2 +         &
+                               ( 0.5_wp * ( w(nzb:nzt-1,j,i) + w(nzb+1:nzt,j,  i) ) )**2 )
     ENDIF
 !
 !-- Calculate conversion factors for gas concentrations
-    ppm_to_nconc = for_ppm_to_nconc * in_p / in_t
+    ppm_to_nconc(:) = for_ppm_to_nconc * in_p(:) / in_t(:)
 !
 !-- Determine topography-top index on scalar grid
-    k_wall = MAXLOC( MERGE( 1, 0, BTEST( wall_flags_0(:,j,i), 12 ) ),          &
-                     DIM = 1 ) - 1     
-               
+    k_wall = k_topo_top(j,i)
+
     DO k = nzb+1, nzt
 !
 !--    Predetermine flag to mask topography
        flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
-!       
-!--    Do not run inside buildings        
-       IF ( flag == 0.0_wp )  CYCLE   
-!
-!--    Wind velocity for dry depositon on vegetation   
-       IF ( lsdepo_vege  .AND.  plant_canopy  )  THEN
-          in_lad = lad_s(k-k_wall,j,i)
-       ENDIF       
+!
+!--    Wind velocity for dry depositon on vegetation
+       IF ( lsdepo_pcm  .AND.  plant_canopy )  THEN
+          in_lad = lad_s( MAX( k-k_wall,0 ),j,i)
+       ENDIF
 !
 !--    For initialization and spinup, limit the RH with the parameter rhlim
@@ -2284,128 +2541,127 @@
        ENDIF
        cw_old = in_cw(k) !* in_adn(k)
-!                
+!
 !--    Set volume concentrations:
 !--    Sulphate (SO4) or sulphuric acid H2SO4 
-       IF ( iso4 > 0 )  THEN
+       IF ( index_so4 > 0 )  THEN
           vc = 1
-          str = ( iso4-1 ) * nbins + 1    ! start index
-          endi = iso4 * nbins             ! end index
-          cc = 1
+          str = ( index_so4-1 ) * nbins_aerosol + 1    ! start index
+          endi = index_so4 * nbins_aerosol             ! end index
+          ic = 1
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoh2so4
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoh2so4
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-       
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Organic carbon (OC) compounds
-       IF ( ioc > 0 )  THEN
+       IF ( index_oc > 0 )  THEN
           vc = 2
-          str = ( ioc-1 ) * nbins + 1
-          endi = ioc * nbins
-          cc = 1
+          str = ( index_oc-1 ) * nbins_aerosol + 1
+          endi = index_oc * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhooc 
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhooc
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-       
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Black carbon (BC)
-       IF ( ibc > 0 )  THEN
+       IF ( index_bc > 0 )  THEN
           vc = 3
-          str = ( ibc-1 ) * nbins + 1 + fn1a
-          endi = ibc * nbins
-          cc = 1 + fn1a
+          str = ( index_bc-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_bc * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhobc 
-             cc = cc+1
-          ENDDO                   
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhobc
+             ic = ic+1
+          ENDDO
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Dust (DU)
-       IF ( idu > 0 )  THEN
+       IF ( index_du > 0 )  THEN
           vc = 4
-          str = ( idu-1 ) * nbins + 1 + fn1a
-          endi = idu * nbins
-          cc = 1 + fn1a
+          str = ( index_du-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_du * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhodu 
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhodu
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Sea salt (SS)
-       IF ( iss > 0 )  THEN
+       IF ( index_ss > 0 )  THEN
           vc = 5
-          str = ( iss-1 ) * nbins + 1 + fn1a
-          endi = iss * nbins
-          cc = 1 + fn1a
+          str = ( index_ss-1 ) * nbins_aerosol + 1 + end_subrange_1a
+          endi = index_ss * nbins_aerosol
+          ic = 1 + end_subrange_1a
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoss  
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoss
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Nitrate (NO(3-)) or nitric acid HNO3
-       IF ( ino > 0 )  THEN
+       IF ( index_no > 0 )  THEN
           vc = 6
-          str = ( ino-1 ) * nbins + 1 
-          endi = ino * nbins
-          cc = 1
+          str = ( index_no-1 ) * nbins_aerosol + 1 
+          endi = index_no * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhohno3 
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhohno3
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Ammonium (NH(4+)) or ammonia NH3
-       IF ( inh > 0 )  THEN
+       IF ( index_nh > 0 )  THEN
           vc = 7
-          str = ( inh-1 ) * nbins + 1
-          endi = inh * nbins
-          cc = 1
+          str = ( index_nh-1 ) * nbins_aerosol + 1
+          endi = index_nh * nbins_aerosol
+          ic = 1
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhonh3  
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhonh3
+             ic = ic+1
           ENDDO
-          aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
-       ENDIF
-
+          aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
+       ENDIF
+!
 !--    Water (always used)
        nc_h2o = get_index( prtcl,'H2O' )
        vc = 8
-       str = ( nc_h2o-1 ) * nbins + 1
-       endi = nc_h2o * nbins
-       cc = 1
+       str = ( nc_h2o-1 ) * nbins_aerosol + 1
+       endi = nc_h2o * nbins_aerosol
+       ic = 1
        IF ( advect_particle_water )  THEN
           DO ss = str, endi
-             aero(cc)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoh2o 
-             cc = cc+1
+             aero(ic)%volc(vc) = aerosol_mass(ss)%conc(k,j,i) / arhoh2o
+             ic = ic+1
           ENDDO
        ELSE
-         aero(1:nbins)%volc(vc) = mclim 
-       ENDIF
-       aero_old(1:nbins)%volc(vc) = aero(1:nbins)%volc(vc)
+         aero(1:nbins_aerosol)%volc(vc) = mclim 
+       ENDIF
+       aero_old(1:nbins_aerosol)%volc(vc) = aero(1:nbins_aerosol)%volc(vc)
 !
 !--    Number concentrations (numc) and particle sizes 
 !--    (dwet = wet diameter, core = dry volume)
-       DO  bb = 1, nbins
-          aero(bb)%numc = aerosol_number(bb)%conc(k,j,i)  
-          aero_old(bb)%numc = aero(bb)%numc
-          IF ( aero(bb)%numc > nclim )  THEN
-             aero(bb)%dwet = ( SUM( aero(bb)%volc(:) ) / aero(bb)%numc / api6 )&
-                                **( 1.0_wp / 3.0_wp )
-             aero(bb)%core = SUM( aero(bb)%volc(1:7) ) / aero(bb)%numc 
+       DO  ib = 1, nbins_aerosol
+          aero(ib)%numc = aerosol_number(ib)%conc(k,j,i)
+          aero_old(ib)%numc = aero(ib)%numc
+          IF ( aero(ib)%numc > nclim )  THEN
+             aero(ib)%dwet = ( SUM( aero(ib)%volc(:) ) / aero(ib)%numc / api6 )**0.33333333_wp
+             aero(ib)%core = SUM( aero(ib)%volc(1:7) ) / aero(ib)%numc
           ELSE
-             aero(bb)%dwet = aero(bb)%dmid
-             aero(bb)%core = api6 * ( aero(bb)%dwet ) ** 3.0_wp
+             aero(ib)%dwet = aero(ib)%dmid
+             aero(ib)%core = api6 * ( aero(ib)%dwet )**3
           ENDIF
        ENDDO
-!       
+!
 !--    On EACH call of salsa_driver, calculate the ambient sizes of 
 !--    particles by equilibrating soluble fraction of particles with water
